import { Browser, BrowserConnectOptions, BrowserLaunchArgumentOptions, LaunchOptions as PPTLaunchOptions, Page, Product } from 'puppeteer';
import * as Config from 'lighthouse/types/config';
import { UserFlow } from 'lighthouse/lighthouse-core/fraggle-rock/user-flow';
import { SharedFlagsSettings } from 'lighthouse/types/lhr/settings';
export declare type UserFlowContext = {
    browser: Browser;
    page: Page;
    flow: UserFlow;
    collectOptions: {
        url: string;
    };
};
export declare type StepOptions = {
    stepName: string;
} & {
    config?: Config.default.Json;
};
export declare type UserFlowInteractionsFn = (context: UserFlowContext) => Promise<void>;
export declare type UserFlowOptions = {
    name: string;
} & {
    config?: Config.default.Json;
};
export declare type LaunchOptions = PPTLaunchOptions & BrowserLaunchArgumentOptions & BrowserConnectOptions & {
    product?: Product;
    extraPrefsFirefox?: Record<string, unknown>;
};
/**
 * budgets: path to budgets file
 */
declare type UserFlowRcOptions = {
    config: {
        settings: {
            budgets: string | SharedFlagsSettings['budgets'];
        };
    };
} & UserFlowOptions;
export declare type UserFlowProvider = {
    flowOptions: UserFlowOptions | UserFlowRcOptions;
    interactions: UserFlowInteractionsFn;
    launchOptions?: LaunchOptions;
};
export {};
