"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initCommand = void 0;
const tslib_1 = require("tslib");
const loggin_1 = require("../../core/utils/loggin");
const options_1 = require("./options");
const yargs_1 = require("../../core/utils/yargs");
const utils_1 = require("./utils");
const setup_rc_json_1 = require("./processes/setup-rc-json");
const prompt_1 = require("../../core/utils/prompt");
const behaviors_1 = require("../../core/utils/processing/behaviors");
const file_1 = require("../../core/utils/file");
const constants_1 = require("./constants");
exports.initCommand = {
    command: 'init',
    description: 'Setup .user-flowrc.json',
    builder: (y) => y.options(options_1.INIT_OPTIONS),
    module: {
        handler: (argv) => (0, tslib_1.__awaiter)(void 0, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`run "init" as a yargs command`);
            const potentialExistingCfg = (0, yargs_1.getCLIConfigFromArgv)(argv);
            const exampleName = 'basic-navigation';
            const userflowIsNotCreated = (cfg) => Promise.resolve(cfg ? (0, file_1.readFile)((0, utils_1.getExamplePathDest)(exampleName, cfg.collect.ufPath)) === '' : false);
            yield (0, behaviors_1.run)([
                setup_rc_json_1.setupRcJson,
                (0, prompt_1.askToSkip)('Setup user flow', (cfg) => (0, tslib_1.__awaiter)(void 0, void 0, void 0, function* () {
                    (0, utils_1.addUserFlow)(exampleName, cfg.collect.ufPath);
                    return Promise.resolve(cfg);
                }), {
                    precondition: userflowIsNotCreated
                })
            ])(potentialExistingCfg);
            (0, loggin_1.log)(constants_1.SETUP_CONFIRM_MESSAGE);
            // @TODO move to constants
            (0, loggin_1.log)('To execute a user flow run `npx user-flow` or `npx user-flow collect`');
        })
    }
};
//# sourceMappingURL=index.js.map